AES
	proc
		//Args
		//	T - the text to convert to a binary array
		//Returns an array of bits representing the text T
		text2binary(T)
			var/retVal[length(T) * 8]
			for(var/i = 1; i <= length(T); i++)
				var/char = text2ascii(T,i)
				for(var/j = 8; j >= 1; j--)
					retVal[(i-1)*8+j] = char%2
					char -= char%2
					char /= 2
			return retVal

		//Args
		//	B - the array of bits to convert to text
		//Returns text representing the array of bits B
		binary2text(list/B)
			var/retVal
			for(var/i = 0; i < length(B)/8; i++)
				var/decimal = 0
				var/power = 0
				for(var/j = 8; j >= 1; j--)
					decimal += (2**(power++)) * B[i*8+j]
				retVal += ascii2text(decimal)
			return retVal

		//Args
		//	T - the text to convert to a int array
		//Returns an array of ints representing the text T
		text2int(T)
			var/retVal[length(T)]
			for(var/i = 1; i <= length(T); i++)
				retVal[i] = text2ascii(T, i)
			return retVal

		//Args
		//	D - the array of ints to convert to text
		//Returns text representing the array of ints D
		int2text(list/D)
			var/retVal
			for(var/i = 1; i <= length(D); i++)
				retVal += ascii2text(D[i])

		//Args
		//	H - the hex string to convert to an int array
		//Returns an array of ints representing H
		hex2int(H)
			var/list/retVal = list()
			for(var/i = 1; i <= length(H); i+=2)
				retVal += base2dec(copytext(H,i,i+2),16)
			return retVal

		//Args
		//	T - the text to convert into a 4x4 int matrix
		//Returns the 4x4 matrix representing the text
		text2mat(T)
			var/blocks = round(length(T)/16)
			if(length(T)%16) blocks += 1
			var/retVal[blocks*4][4]
			var/cnt = 1
			for(var/i = 1; i <= blocks*4; i++)
				for(var/j = 1; j <= 4; j++)
					retVal[i][j] = text2ascii(T, cnt++)
			return retVal

		//Args
		//M - the 4x4 int matrix to convert to text
		//Returns the text representation of the 4x4 matrix
		mat2text(list/M)
			var/blocks = length(M)
			var/retVal
			for(var/i = 1; i <= blocks; i++)
				for(var/j = 1; j <= 4; j++)
					retVal += ascii2text(M[i][j])
			return retVal

		hex2mat(H)
			var/blocks = round(length(H)/32)
			if(length(H)%32) blocks += 1
			var/retVal[blocks*4][4]
			var/cnt = 1
			for(var/i = 1; i <= blocks*4; i++)
				for(var/j = 1; j <= 4; j++)
					retVal[i][j] = base2dec(copytext(H,cnt,cnt+2),16)
					cnt += 2
			return retVal

		mat2hex(list/M)
			var/blocks = length(M)
			var/retVal
			for(var/i = 1; i <= blocks; i++)
				for(var/j = 1; j <= 4; j++)
					retVal += dec2base(M[i][j], 16)
			return retVal